SystemOrganization addCategory: #CSA!
SystemOrganization addCategory: #'CSA-Test'!

Object subclass: #CSAClassSource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

CSAClassSource subclass: #CSACategoryClassSource
	instanceVariableNames: 'wildcard'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

!CSACategoryClassSource class methodsFor: 'as yet unclassified' stamp: 'sk 12/5/2011 12:03:00.362'!
for: aString
	^ self new
		wildcard: aString;
		yourself  ! !

!CSACategoryClassSource methodsFor: 'accessing' stamp: 'sk 12/5/2011 12:02:24.847'!
contains: aClass
	^ self wildcard match: aClass category  ! !

!CSACategoryClassSource methodsFor: 'accessing' stamp: 'sk 12/5/2011 12:01:43.246'!
getClasses
	^ SmalltalkImage current allClasses select:
		[ : class | self contains: class ]! !

!CSACategoryClassSource methodsFor: 'accessing' stamp: 'sk 12/5/2011 11:59:27.41'!
wildcard
	^ wildcard! !

!CSACategoryClassSource methodsFor: 'accessing' stamp: 'sk 12/5/2011 11:59:27.438'!
wildcard: aString
	wildcard := aString
! !

!CSAClassSource methodsFor: 'as yet unclassified' stamp: 'sk 12/4/2011 22:38:56.558'!
getClasses
"Returns the classes of this source."
	self subclassResponsibility ! !

CSAClassSource subclass: #CSASingleClassSource
	instanceVariableNames: 'containedClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

!CSASingleClassSource class methodsFor: 'instance creation' stamp: 'sk 12/4/2011 23:23:46.152'!
for: aClass
	^ self new
		containedClass: aClass;
		yourself  ! !

!CSASingleClassSource methodsFor: 'accessing' stamp: 'sk 12/4/2011 22:42:31.441'!
containedClass
	^ containedClass! !

!CSASingleClassSource methodsFor: 'accessing' stamp: 'sk 12/4/2011 22:42:52.644'!
containedClass: aClass
	containedClass := aClass.! !

!CSASingleClassSource methodsFor: 'as yet unclassified' stamp: 'sk 12/4/2011 22:43:07.12'!
getClasses 
	^ OrderedCollection new
		add: self containedClass;
		yourself! !

CSAClassSource subclass: #CSAWildcardClassSource
	instanceVariableNames: 'wildcard'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

!CSAWildcardClassSource class methodsFor: 'instance creation' stamp: 'sk 12/5/2011 00:50:39.949'!
for: aString
	^ (self new)
		wildcard: aString;
		yourself   ! !

!CSAWildcardClassSource methodsFor: 'matching' stamp: 'sk 12/5/2011 13:09:38.033'!
contains: aClass
	^ self wildcard match: aClass asString! !

!CSAWildcardClassSource methodsFor: 'as yet unclassified' stamp: 'sk 12/5/2011 00:23:53.831'!
getClasses
	^ SmalltalkImage current allClasses select: 
		[ :class | self contains: class asString]! !

!CSAWildcardClassSource methodsFor: 'accessing' stamp: 'sk 12/5/2011 00:18:57.184'!
wildcard
	^ wildcard! !

!CSAWildcardClassSource methodsFor: 'accessing' stamp: 'sk 12/5/2011 00:18:57.207'!
wildcard: aString
	wildcard := aString 
! !

Object subclass: #CSAEventDispatcher
	instanceVariableNames: 'metrics filters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

!CSAEventDispatcher class methodsFor: 'as yet unclassified' stamp: 'sk 11/30/2011 16:22:08.494'!
unregisterAllInstances

	self allInstancesDo:
		[:runner | runner unregisterAsObserver].  ! !

!CSAEventDispatcher class methodsFor: 'instance creation' stamp: 'f.z 11/30/2011 17:40:36.102'!
with: aCollectionOfFilters
	^ self new
		filters: aCollectionOfFilters;
		yourself! !

!CSAEventDispatcher methodsFor: 'accessing' stamp: 'f.z 11/30/2011 17:57:40.981'!
addFilter: aFilter
	self filters add: aFilter! !

!CSAEventDispatcher methodsFor: 'accessing' stamp: 'f.z 11/30/2011 18:10:53.894'!
addMetric: aMetric
	self metrics add: aMetric! !

!CSAEventDispatcher methodsFor: 'events' stamp: 'f.z 11/30/2011 18:05:02.694'!
broadcast: anEvent
	self metrics do:
		[ :metric | metric process: anEvent ]! !

!CSAEventDispatcher methodsFor: 'events' stamp: 'sk 12/5/2011 13:18:39.007'!
dispatch: anEvent
	(self isInterestedIn: anEvent)
		ifTrue: [ self broadcast: anEvent ]! !

!CSAEventDispatcher methodsFor: 'accessing' stamp: 'f.z 11/30/2011 17:41:25.871'!
filters
	^ filters! !

!CSAEventDispatcher methodsFor: 'accessing' stamp: 'f.z 11/30/2011 17:41:25.882'!
filters: aCollection
	filters := aCollection! !

!CSAEventDispatcher methodsFor: 'initialize' stamp: 'f.z 11/30/2011 18:11:24.374'!
initialize
	self 
		filters: OrderedCollection new;
		metrics: OrderedCollection new  ! !

!CSAEventDispatcher methodsFor: 'events' stamp: 'f.z 12/1/2011 11:16:16.375'!
isInterestedIn: anEvent
	^ self filters allSatisfy: [ :filter | filter isInterestedIn: anEvent ]  ! !

!CSAEventDispatcher methodsFor: 'accessing' stamp: 'f.z 11/30/2011 18:10:37.334'!
metrics
	^ metrics! !

!CSAEventDispatcher methodsFor: 'accessing' stamp: 'f.z 11/30/2011 18:10:37.376'!
metrics: aCollection
	metrics := aCollection
! !

!CSAEventDispatcher methodsFor: 'accessing' stamp: 'f.z 11/30/2011 17:18:36.245'!
notifier
	^ SystemChangeNotifier uniqueInstance! !

!CSAEventDispatcher methodsFor: 'registering' stamp: 'f.z 11/30/2011 17:26:42.102'!
registerAsObserver 
 "Erstmal alle Systemevents abholen und spter dispatchen"
	self notifier notify: self ofAllSystemChangesUsing: #dispatch:.! !

!CSAEventDispatcher methodsFor: 'registering' stamp: 'f.z 12/1/2011 11:20:26.823'!
unregisterAsObserver
	self notifier noMoreNotificationsFor: self! !

Object subclass: #CSAEventFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

CSAEventFilter subclass: #CSACategoryFilter
	instanceVariableNames: 'wildcardMatcher'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

!CSACategoryFilter class methodsFor: 'instance creation' stamp: 'f.z 11/30/2011 18:18:56.023'!
for: aString
	^ self new
		wildcardMatcher: aString;
		yourself! !

!CSACategoryFilter methodsFor: 'filtering' stamp: 'f.z 12/1/2011 11:35:12.876'!
categoryFor: anEvent
	^ (self classFor: anEvent) category  ! !

!CSACategoryFilter methodsFor: 'filtering' stamp: 'f.z 12/1/2011 11:39:33.431'!
classFor: anEvent
	"Answers the class that the given event applies to. I am only interested in
	method and class events."
	anEvent itemKind = AbstractEvent classKind ifTrue: [ ^ anEvent item ].
	^ anEvent item methodClass! !

!CSACategoryFilter methodsFor: 'initialize' stamp: 'f.z 12/1/2011 11:41:30.311'!
initialize
	self wildcardMatcher: '*'! !

!CSACategoryFilter methodsFor: 'filtering' stamp: 'f.z 12/1/2011 11:33:58.648'!
isInterestedIn: anEvent
	(self isOfCorrectKind: anEvent)
		ifFalse: [ ^ false ].
	^ self wildcardMatcher match: (self categoryFor: anEvent)! !

!CSACategoryFilter methodsFor: 'filtering' stamp: 'f.z 12/1/2011 11:38:50.671'!
isOfCorrectKind: anEvent
	anEvent itemKind = AbstractEvent methodKind ifTrue: [ ^ true ].
	anEvent itemKind = AbstractEvent classKind ifTrue: [ ^ true ].
	^ false! !

!CSACategoryFilter methodsFor: 'accessing' stamp: 'f.z 11/30/2011 18:19:30.454'!
wildcardMatcher
	^ wildcardMatcher! !

!CSACategoryFilter methodsFor: 'accessing' stamp: 'f.z 11/30/2011 18:19:30.513'!
wildcardMatcher: aString
	wildcardMatcher := aString
! !

!CSAEventFilter methodsFor: 'filtering' stamp: 'f.z 11/30/2011 18:14:04.134'!
isInterestedIn: anEvent
	self subclassResponsibility! !

CSAEventFilter subclass: #CSAFalseFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Test'!

!CSAFalseFilter methodsFor: 'filtering' stamp: 'f.z 12/1/2011 11:23:22.664'!
isInterestedIn: anEvent
	^ false! !

CSAEventFilter subclass: #CSATrueFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Test'!

!CSATrueFilter methodsFor: 'filtering' stamp: 'f.z 11/30/2011 17:53:10.886'!
isInterestedIn: anEvent
	^ true  ! !

Object subclass: #CSAMetric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

CSAMetric subclass: #CSAExploreMetric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

!CSAExploreMetric methodsFor: 'event-processing' stamp: 'sk 12/5/2011 13:16:40.734'!
process: anEvent
	anEvent explore  ! !

CSAMetric subclass: #CSAInheritanceDepthMetric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

!CSAInheritanceDepthMetric methodsFor: 'as yet unclassified' stamp: 'sk 12/5/2011 12:18:19.789'!
determineInheritenceDepth: aClass
	| depth curClass |
	depth := 0.
	curClass := aClass.
	[ curClass ~= Object ] whileTrue: 
		[ (curClass == nil) ifTrue: [ ^ -1 ].  
		curClass := curClass superclass.
		depth := depth + 1 ].
	^ depth   ! !

!CSAInheritanceDepthMetric methodsFor: 'as yet unclassified' stamp: 'sk 12/5/2011 12:16:25.381'!
initializeFrom: aCSAClassSource
	| min max sum count |
	max := sum := count := 0.
	min := SmalltalkImage current allClasses size.
	aCSAClassSource getClasses do:
		[ :class | | depth |
		depth := self determineInheritenceDepth: class.
		(depth >= 0) ifTrue:
			[ min := min min: depth.
			max := max max: depth.
			sum := sum + depth.
			count := count + 1 ] 
		ifFalse: [Transcript show: 'Undefined: ', class; cr  ]  ].
	Transcript
		show: 'Min depth is ', min; cr;
		show: 'Max depth is ', max; cr;
		show: 'Average depth is ', (sum / count) asFloat.    ! !

CSAMetric subclass: #CSALinesOfCodeMetric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

!CSALinesOfCodeMetric methodsFor: 'event-processing' stamp: 'sk 12/4/2011 23:34:36.764'!
initializeFrom: aClassSource
	aClassSource getClasses do:
		[ :class | self read: class ]! !

!CSALinesOfCodeMetric methodsFor: 'event-processing' stamp: 'sk 12/4/2011 23:31:37.153'!
process: anEvent
	self error: 'Implement me!!'! !

!CSALinesOfCodeMetric methodsFor: 'event-processing' stamp: 'sk 12/4/2011 23:42:00.223'!
read: aClass
	aClass methodDict keysAndValuesDo: 
		[ :k :v | Transcript show: k; cr; show: v; cr ]  ! !

CSAMetric subclass: #CSAMethodMetric
	instanceVariableNames: 'analysedMethod'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

!CSAMethodMetric methodsFor: 'accessing' stamp: 'ck 12/4/2011 22:00:49.388'!
analysedMethod
	^ analysedMethod! !

!CSAMethodMetric methodsFor: 'accessing' stamp: 'ck 12/4/2011 22:00:49.4'!
analysedMethod: anCompiledMethod
	analysedMethod := anCompiledMethod
! !

!CSAMethodMetric methodsFor: 'metrics' stamp: 'ck 12/4/2011 23:33:26.072'!
hasComment
	"relies on the convention, that the method comment is in the second line of the source code"
	| comment |
	comment := (analysedMethod getSource asString lines at: 2) withBlanksTrimmed.
	^ comment matchesRegex: '\"..*\"'! !

!CSAMethodMetric methodsFor: 'event-processing' stamp: 'ck 12/4/2011 23:23:46.044'!
isInterestedIn: anEvent
	
	  	anEvent itemKind = #method
		ifTrue: 
			[ ^ anEvent isModified ].
		^ False
		! !

!CSAMethodMetric methodsFor: 'metrics' stamp: 'ck 12/4/2011 23:26:16.55'!
linesOfCode
		
		^ analysedMethod  linesOfCode! !

!CSAMethodMetric methodsFor: 'metrics' stamp: 'ck 12/4/2011 23:27:12.534'!
numberOfArguments
	
	^ analysedMethod  numArgs! !

!CSAMethodMetric methodsFor: 'metrics' stamp: 'ck 12/4/2011 23:32:53.872'!
numberOfTemporaries
	"gives the number of temporaries including the arguments"
	^ analysedMethod  numTemps! !

!CSAMethodMetric methodsFor: 'metrics' stamp: 'ck 12/4/2011 23:29:44.134'!
overridesMethod
	^ analysedMethod sourceClass allSuperclasses anySatisfy: 
			[:class | class methodDict anySatisfy:   
				[:method | method selector name = analysedMethod selector name]]! !

!CSAMethodMetric methodsFor: 'event-processing' stamp: 'ck 12/4/2011 23:31:56.288'!
process: anEvent

	(self isInterestedIn: anEvent)   
		ifTrue: [ 
			self analysedMethod: anEvent item.
			self 
				hasComment;
				linesOfCode;
				numberOfTemporaries;
				numberOfArguments;
				overridesMethod;
				sendsMessages;
				sendsSuper;
				usedInstanceVariables   ]! !

!CSAMethodMetric methodsFor: 'metrics' stamp: 'ck 12/4/2011 23:26:53.714'!
sendsMessages 
	
	^ analysedMethod  messages! !

!CSAMethodMetric methodsFor: 'metrics' stamp: 'ck 12/4/2011 23:26:34.334'!
sendsSuper

		^ analysedMethod  sendsToSuper! !

!CSAMethodMetric methodsFor: 'metrics' stamp: 'ck 12/4/2011 23:29:22.662'!
usedInstanceVariables
	| allInstanceVariables |
	allInstanceVariables := analysedMethod sourceClass allInstVarNames.
	^ allInstanceVariables select: 
			[:variable | 
				analysedMethod readsField: 
					(allInstanceVariables indexOf: variable) ]! !

!CSAMetric methodsFor: 'event-processing' stamp: 'f.z 11/30/2011 18:14:37.27'!
process: anEvent
	self subclassResponsibility! !

CSAMetric subclass: #CSATranscriptMetric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

!CSATranscriptMetric methodsFor: 'event-processing' stamp: 'sk 12/4/2011 22:30:01.074'!
process: anEvent
	Transcript 
		show: '--- Received an event: '; cr; 
		show: anEvent; cr;
		show: '--- End of event';
		cr;
		cr! !

Object subclass: #CSAWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

TestCase subclass: #CSAEventDispatcherTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Test'!

!CSAEventDispatcherTest methodsFor: 'filter-testing' stamp: 'f.z 11/30/2011 17:59:09.445'!
testFalseFilter
	| dispatcher |
	dispatcher := CSAEventDispatcher new.
	dispatcher addFilter: CSAFalseFilter new.
	self deny: [ dispatcher isInterestedIn: nil ]! !

!CSAEventDispatcherTest methodsFor: 'filter-testing' stamp: 'f.z 11/30/2011 17:56:04.166'!
testNoFilters
	| dispatcher |
	dispatcher := CSAEventDispatcher new.
	self assert: [ dispatcher isInterestedIn: nil ]! !

!CSAEventDispatcherTest methodsFor: 'filter-testing' stamp: 'f.z 11/30/2011 17:58:10.966'!
testTrueFilter
	| dispatcher |
	dispatcher := CSAEventDispatcher new.
	dispatcher addFilter: CSATrueFilter new.
	self assert: [ dispatcher isInterestedIn: nil ]  ! !

!CSAEventDispatcherTest methodsFor: 'filter-testing' stamp: 'f.z 11/30/2011 17:59:37.35'!
testTwoFilters
	| dispatcher |
	dispatcher := CSAEventDispatcher new.
	dispatcher addFilter: CSAFalseFilter new.
	dispatcher addFilter: CSATrueFilter new.  
	self deny: [ dispatcher isInterestedIn: nil ]! !

TestCase subclass: #CSASingleClassSourceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Test'!

!CSASingleClassSourceTest methodsFor: 'as yet unclassified' stamp: 'sk 12/4/2011 23:30:16.17'!
testGetClasses
	| classes |
	classes := (CSASingleClassSource for: String class) getClasses.
	self assert: classes size == 1.
	self assert: (classes contains: [:item | item == String class]).! !
